'From Squeak3.1alpha of 6 February 2001 [latest update: #3740] on 8 March 2001 at 10:06:03 pm'!
Link subclass: #Process
	instanceVariableNames: 'suspendedContext priority myList errorHandler runDuration startTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Interpreter methodsFor: 'processes' stamp: 'JMM 3/8/2001 21:39'!
transferTo: aProc 
	"Record a process to be awoken on the next interpreter cycle.  
	ikp 11/24/1999 06:07 -- added hook for external runtime compiler"
	| sched oldProc newProc now duration |
	newProc _ aProc.
	sched _ self schedulerPointer.
	oldProc _ self fetchPointer: ActiveProcessIndex ofObject: sched.
	(self slotSizeOf: oldProc) > 5 ifTrue: 
		[now _ self ioMSecs bitAnd: MillisecondClockMask.
		duration _ now
				- (self fetchInteger: 6 ofObject: oldProc)
				+ (self fetchInteger: 5 ofObject: oldProc).
		self
			storeInteger: 5
			ofObject: oldProc
			withValue: duration.
		self
			storeInteger: 6
			ofObject: newProc
			withValue: now].
	self
		storePointer: ActiveProcessIndex
		ofObject: sched
		withValue: newProc.
	compilerInitialized
		ifTrue: [self compilerProcessChange: oldProc to: newProc]
		ifFalse: [self
				storePointer: SuspendedContextIndex
				ofObject: oldProc
				withValue: activeContext.
			self
				newActiveContext: (self fetchPointer: SuspendedContextIndex ofObject: newProc)].
	reclaimableContextCount _ 0! !


!Process methodsFor: 'accessing' stamp: 'JMM 3/8/2001 21:03'!
runDuration
	^runDuration! !

!Process methodsFor: 'accessing' stamp: 'JMM 3/8/2001 21:03'!
runDuration: aNumber
	runDuration _ aNumber! !

!Process methodsFor: 'accessing' stamp: 'JMM 3/8/2001 21:04'!
startTime 
	^startTime! !

!Process methodsFor: 'accessing' stamp: 'JMM 3/8/2001 21:04'!
startTime: aValue
	startTime _ aValue! !

!Process methodsFor: 'printing' stamp: 'JMM 3/8/2001 21:05'!
browserPrintStringWith: anObject 
	| stream |
	stream _ WriteStream
				on: (String new: 100).
	stream nextPut: $(.
	priority printOn: stream.
	self isSuspended
		ifTrue: [stream nextPut: $s].
	stream nextPutAll: ') '.
	stream nextPut: $(.
	self runDuration printOn: stream.
	stream nextPutAll: ') '.
	stream
		nextPutAll: ((self respondsTo: #processName)
				ifTrue: [self processName]
				ifFalse: [self hash asString forceTo: 5 paddingStartWith: $ ]).
	stream space.
	stream nextPutAll: anObject asString.
	^ stream contents! !

!Process methodsFor: 'printing' stamp: 'JMM 3/8/2001 22:04'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' in '.
	suspendedContext printOn: aStream.
	aStream nextPutAll: ' RunTime '.
	runDuration printOn: aStream! !


!Process class methodsFor: 'instance creation' stamp: 'JMM 3/8/2001 21:04'!
forContext: aContext priority: anInteger 
	"Answer an instance of me that has suspended aContext at priority 
	anInteger."

	| newProcess |
	newProcess _ self new.
	newProcess suspendedContext: aContext.
	newProcess priority: anInteger.
	newProcess startTime: 0.
	newProcess runDuration: 0.
	^newProcess! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."
!

